% copied from https://tex.stackexchange.com/a/83883
% Default fixed font does not support bold face
%\DeclareFixedFont{\ttb}{T1}{txtt}{bx}{n}{12} % for bold
%\DeclareFixedFont{\ttm}{T1}{txtt}{m}{n}{12}  % for normal

% Custom colors
\usepackage{color}
\definecolor{deepblue}{rgb}{0,0,0.5}
\definecolor{deepred}{rgb}{0.6,0,0}
\definecolor{deepgreen}{rgb}{0,0.5,0}
\definecolor{grey}{rgb}{0.2,0.2,0.2}
\definecolor{background}{rgb}{0.9,0.9,0.9}


% Python style for highlighting
\newcommand\pythonstyle{\lstset{
  language=Python,
  basicstyle=\footnotesize\ttfamily,
  otherkeywords={self},             % Add keywords here
  keywordstyle=\footnotesize\bfseries\color{deepblue},
  emph={MyClass,__init__},          % Custom highlighting
  emphstyle=\footnotesize\bfseries\color{deepred},    % Custom highlighting style
  stringstyle=\color{deepgreen},
  captionpos=b,
  keepspaces=true,
  numbers=left,
  numbersep=3pt,
  showspaces=false,
  numberstyle=\tiny\color{grey},
  aboveskip=5pt,
  upquote=true,
  columns=fixed,
  extendedchars=true,
  breaklines=true,
  %frame=false,
  showstringspaces=true,
  showtabs=true,
  tab=\rightarrowfill,
  tabsize=2,
  %backgroundcolor=\color{background},
}}

\lstdefinelanguage{json}{
    basicstyle=\footnotesize\ttfamily,
    %commentstyle=\color{deepred}, % style of comment
    stringstyle=\color{deepgreen}, % style of strings
    numbers=left,
    numberstyle=\tiny\color{grey},
    stepnumber=1,
    numbersep=3pt,
    showstringspaces=false,
    breaklines=true,
    %frame=lines,
    %backgroundcolor=\color{background},
    string=[s]{"}{"},
    comment=[l]{:\ "},
    morecomment=[l]{:"},
    literate=
        *{0}{{{\color{deepgreen}0}}}{1}
         {1}{{{\color{deepgreen}1}}}{1}
         {2}{{{\color{deepgreen}2}}}{1}
         {3}{{{\color{deepgreen}3}}}{1}
         {4}{{{\color{deepgreen}4}}}{1}
         {5}{{{\color{deepgreen}5}}}{1}
         {6}{{{\color{deepgreen}6}}}{1}
         {7}{{{\color{deepgreen}7}}}{1}
         {8}{{{\color{deepgreen}8}}}{1}
         {9}{{{\color{deepgreen}9}}}{1}
}

% Python environment
\lstnewenvironment{python}[1][]
{
\pythonstyle
\lstset{#1}
}
{}

% Python for external files
\newcommand\pythonexternal[2][]{{
\pythonstyle
\lstinputlisting[#1]{#2}}}

% Python for inline
\newcommand\pythoninline[1]{{\pythonstyle\lstinline!#1!}}

% Bash style for highlighting
\newcommand\bashstyle{\lstset{
language=Bash,
basicstyle=\footnotesize\ttfamily,
keywordstyle=\footnotesize\bfseries\color{deepblue},
emphstyle=\footnotesize\bfseries\color{deepred},    % Custom highlighting style
stringstyle=\color{deepgreen},
captionpos=b,
keepspaces=true,
numbers=left,
numbersep=3pt,
showspaces=false,
breaklines=true,
numberstyle=\tiny\color{grey}
}}
% Bash environment
\lstnewenvironment{bash}[1][]
{
\bashstyle
\lstset{#1}
}
{}

% Bash for external files
\newcommand\bashexternal[2][]{{
\bashstyle
\lstinputlisting[#1]{#2}}}

% Bahs for inline
\newcommand\bashinline[1]{{\bashstyle\lstinline!#1!}}

